import type { CreateRemoteConfig, BootstrapOptions, MountOptions, Cleanup, CreateRuntime, MountFunc } from "@leanjs/core";
import type { Component } from "vue";
import type { RouteRecordRaw, RouterScrollBehavior, parseQuery, stringifyQuery } from "vue-router";
export { CreateRemoteConfig, BootstrapOptions, MountOptions, Cleanup, CreateRuntime, };
interface VueRouterConfig {
    routes?: RouteRecordRaw[];
    scrollBehavior?: RouterScrollBehavior;
    parseQuery?: typeof parseQuery;
    stringifyQuery?: typeof stringifyQuery;
    linkActiveClass?: string;
    linkExactActiveClass?: string;
}
interface CreateRemoteVueConfig<MyCreateRuntime extends CreateRuntime> extends CreateRemoteConfig<MyCreateRuntime> {
    router?: VueRouterConfig;
}
export declare const createApp: <MyCreateRuntime extends CreateRuntime<import("@leanjs/core").Runtime<import("@leanjs/core").BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseCtxFactory<import("@leanjs/core").BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>> = CreateRuntime<import("@leanjs/core").Runtime<import("@leanjs/core").BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseCtxFactory<import("@leanjs/core").BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>>(App: Component, { createRuntime, onBeforeMount, packageName, router: { routes, ...routerConfig }, }: CreateRemoteVueConfig<MyCreateRuntime>) => {
    (options?: BootstrapOptions): {
        mount: MountFunc<ReturnType<MyCreateRuntime>>;
        packageName: string;
        createRuntime: MyCreateRuntime | undefined;
    };
    packageName: string;
};
